<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: field/bmatrix.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_00a13ab5e3afe633796d5c180ae90994.html">field</a>
  </div>
</div>
<div class="contents">
<h1>bmatrix.c</h1><a href="bmatrix_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2002-2010 Werner Scholz</span>
<a name="l00005"></a>00005 <span class="comment"></span>
<a name="l00006"></a>00006 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00007"></a>00007 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00010"></a>00010 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00011"></a>00011 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00012"></a>00012 <span class="comment">    (at your option) any later version.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00015"></a>00015 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00016"></a>00016 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00017"></a>00017 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00020"></a>00020 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00021"></a>00021 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00022"></a>00022 <span class="comment">*/</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="field_8h.html">field/field.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="init_8h.html">init/init.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="util_8h.html">util/util.h</a>&quot;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a><a class="code" href="bmatrix_8c.html#a6ef9ef50f16bc7123b3585a730fa9afa">00028</a> <span class="keywordtype">int</span> <a class="code" href="bmatrix_8c.html#a6ef9ef50f16bc7123b3585a730fa9afa">VertBSA</a>(<a class="code" href="structGridData.html">GridData</a> *gdata,Vec vertbsa)
<a name="l00029"></a>00029 {
<a name="l00030"></a>00030   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00031"></a>00031 
<a name="l00032"></a>00032   <span class="comment">/* Calculate solid angles of boundary vertices */</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034   <span class="comment">/* loop over all local elements */</span>
<a name="l00035"></a>00035   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;gdata-&gt;<a class="code" href="structGridData.html#aa69a0b0a497df4cbeee604d3de4ff0b1">ln_ele</a>; i++) {
<a name="l00036"></a>00036     <span class="comment">/* loop over all vertices */</span>
<a name="l00037"></a>00037     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=0; j&lt;<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>; j++) {
<a name="l00038"></a>00038       PetscReal  t_omega;
<a name="l00039"></a>00039       ierr = <a class="code" href="solidangle_8c.html#a1e2c6c7a1101373c5702b927ca66405f">SolidAngle</a>(
<a name="l00040"></a>00040         gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>+gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[NV*i+j]*<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,
<a name="l00041"></a>00041         gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>+gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[NV*i+(j+1+NV)%NV]*ND,
<a name="l00042"></a>00042         gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>+gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[NV*i+(j+2+NV)%NV]*ND,
<a name="l00043"></a>00043         gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>+gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[NV*i+(j+3+NV)%NV]*ND,
<a name="l00044"></a>00044         &amp;t_omega
<a name="l00045"></a>00045       );CHKERRQ(ierr);
<a name="l00046"></a>00046 
<a name="l00047"></a>00047       <span class="keywordtype">int</span> v;
<a name="l00048"></a>00048       v=gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[NV*i+j];
<a name="l00049"></a>00049       ierr = VecSetValue(
<a name="l00050"></a>00050         vertbsa,
<a name="l00051"></a>00051         v,
<a name="l00052"></a>00052         t_omega,
<a name="l00053"></a>00053       ADD_VALUES);CHKERRQ(ierr);
<a name="l00054"></a>00054     }
<a name="l00055"></a>00055   }
<a name="l00056"></a>00056 
<a name="l00057"></a>00057   ierr = VecAssemblyBegin(vertbsa);CHKERRQ(ierr);
<a name="l00058"></a>00058   ierr = VecAssemblyEnd(vertbsa);CHKERRQ(ierr);
<a name="l00059"></a>00059 
<a name="l00060"></a>00060   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00061"></a>00061 }
<a name="l00062"></a>00062 
<a name="l00063"></a>00063 
<a name="l00064"></a><a class="code" href="field_8h.html#acd4f9c6dd876dbb0affeca8be96ee4b4">00064</a> <span class="keywordtype">int</span> <a class="code" href="bmatrix_8c.html#a02081555af5c4ef64cc4674f52b4d446">BMatrix</a>(<a class="code" href="structGridData.html">GridData</a> *gdata,Mat *Bmat)
<a name="l00065"></a>00065 {
<a name="l00066"></a>00066   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00067"></a>00067 
<a name="l00068"></a>00068   <span class="keywordtype">int</span> rank,size;
<a name="l00069"></a>00069   ierr = MPI_Comm_size(PETSC_COMM_WORLD,&amp;size);CHKERRQ(ierr);
<a name="l00070"></a>00070   ierr = MPI_Comm_rank(PETSC_COMM_WORLD,&amp;rank);CHKERRQ(ierr);
<a name="l00071"></a>00071 
<a name="l00072"></a>00072   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Using dense boundary matrix\n&quot;</span>);
<a name="l00073"></a>00073 
<a name="l00074"></a>00074   PetscPrintf(PETSC_COMM_WORLD,
<a name="l00075"></a>00075     <span class="stringliteral">&quot;Size of dense B matrix: %i x %i = %g matrix elements = %g MB.\n&quot;</span>,
<a name="l00076"></a>00076     gdata-&gt;<a class="code" href="structGridData.html#a916cbd12c058654799cd18db685734c5">n_vert_bnd</a>,
<a name="l00077"></a>00077     gdata-&gt;<a class="code" href="structGridData.html#a916cbd12c058654799cd18db685734c5">n_vert_bnd</a>,
<a name="l00078"></a>00078     1.0*gdata-&gt;<a class="code" href="structGridData.html#a916cbd12c058654799cd18db685734c5">n_vert_bnd</a>*gdata-&gt;<a class="code" href="structGridData.html#a916cbd12c058654799cd18db685734c5">n_vert_bnd</a>,
<a name="l00079"></a>00079     (gdata-&gt;<a class="code" href="structGridData.html#a916cbd12c058654799cd18db685734c5">n_vert_bnd</a>/1024.0*gdata-&gt;<a class="code" href="structGridData.html#a916cbd12c058654799cd18db685734c5">n_vert_bnd</a>/1024.0*<span class="keyword">sizeof</span>(PetscReal))
<a name="l00080"></a>00080   );
<a name="l00081"></a>00081 
<a name="l00082"></a>00082   <span class="comment">/* create boundary matrix (boundary nodes only) */</span>
<a name="l00083"></a>00083 
<a name="l00084"></a>00084   <span class="keywordtype">int</span> ln_bmatrixrows,rowstart,rowend;
<a name="l00085"></a>00085   ln_bmatrixrows=gdata-&gt;<a class="code" href="structGridData.html#a916cbd12c058654799cd18db685734c5">n_vert_bnd</a>/size;
<a name="l00086"></a>00086   rowstart=rank*(gdata-&gt;<a class="code" href="structGridData.html#a916cbd12c058654799cd18db685734c5">n_vert_bnd</a>/size);
<a name="l00087"></a>00087   rowend=rowstart+gdata-&gt;<a class="code" href="structGridData.html#a916cbd12c058654799cd18db685734c5">n_vert_bnd</a>/size-1;
<a name="l00088"></a>00088   <span class="keywordflow">if</span> ((gdata-&gt;<a class="code" href="structGridData.html#a916cbd12c058654799cd18db685734c5">n_vert_bnd</a>%size)/(rank+1)&gt;=1) {
<a name="l00089"></a>00089     ln_bmatrixrows++;
<a name="l00090"></a>00090     rowstart+=rank;
<a name="l00091"></a>00091     rowend+=rank+1;
<a name="l00092"></a>00092   }
<a name="l00093"></a>00093   <span class="keywordflow">else</span> {
<a name="l00094"></a>00094     rowstart+=gdata-&gt;<a class="code" href="structGridData.html#a916cbd12c058654799cd18db685734c5">n_vert_bnd</a>%size;
<a name="l00095"></a>00095     rowend+=gdata-&gt;<a class="code" href="structGridData.html#a916cbd12c058654799cd18db685734c5">n_vert_bnd</a>%size;
<a name="l00096"></a>00096   }
<a name="l00097"></a>00097   PetscSynchronizedPrintf(PETSC_COMM_WORLD,
<a name="l00098"></a>00098     <span class="stringliteral">&quot;&lt;%i&gt;local rows of boundary matrix: %i (from %i to %i)\n&quot;</span>,
<a name="l00099"></a>00099     rank,ln_bmatrixrows,
<a name="l00100"></a>00100     rowstart,rowend
<a name="l00101"></a>00101   );
<a name="l00102"></a>00102   PetscSynchronizedFlush(PETSC_COMM_WORLD);
<a name="l00103"></a>00103   assert(ln_bmatrixrows==rowend-rowstart+1);
<a name="l00104"></a>00104 
<a name="l00105"></a>00105   Mat B;
<a name="l00106"></a>00106 
<a name="l00107"></a>00107   PetscPrintf(PETSC_COMM_WORLD,
<a name="l00108"></a>00108     <span class="stringliteral">&quot;Allocating %i MB of memory for boundary matrix on each processor (total %i MB)\n&quot;</span>,
<a name="l00109"></a>00109     (gdata-&gt;<a class="code" href="structGridData.html#a916cbd12c058654799cd18db685734c5">n_vert_bnd</a>/1024*gdata-&gt;<a class="code" href="structGridData.html#a916cbd12c058654799cd18db685734c5">n_vert_bnd</a>/1024*<span class="keyword">sizeof</span>(PetscReal)+1)/size+1,
<a name="l00110"></a>00110     (gdata-&gt;<a class="code" href="structGridData.html#a916cbd12c058654799cd18db685734c5">n_vert_bnd</a>/1024*gdata-&gt;<a class="code" href="structGridData.html#a916cbd12c058654799cd18db685734c5">n_vert_bnd</a>/1024*<span class="keyword">sizeof</span>(PetscReal)+2)
<a name="l00111"></a>00111   );
<a name="l00112"></a>00112 
<a name="l00113"></a>00113   ierr = MatCreateMPIDense(PETSC_COMM_WORLD,
<a name="l00114"></a>00114     ln_bmatrixrows,ln_bmatrixrows,
<a name="l00115"></a>00115     gdata-&gt;<a class="code" href="structGridData.html#a916cbd12c058654799cd18db685734c5">n_vert_bnd</a>,gdata-&gt;<a class="code" href="structGridData.html#a916cbd12c058654799cd18db685734c5">n_vert_bnd</a>,
<a name="l00116"></a>00116     PETSC_NULL,
<a name="l00117"></a>00117     &amp;B);CHKERRQ(ierr);
<a name="l00118"></a>00118   ierr = MatSetFromOptions(B);CHKERRQ(ierr);
<a name="l00119"></a>00119 
<a name="l00120"></a>00120   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Calculating boundary matrix...\n&quot;</span>);
<a name="l00121"></a>00121 
<a name="l00122"></a>00122   <span class="keywordtype">int</span> zeroes=0;
<a name="l00123"></a>00123 
<a name="l00124"></a>00124   <span class="comment">/*</span>
<a name="l00125"></a>00125 <span class="comment">  hybrid FEM/BEM method from:</span>
<a name="l00126"></a>00126 <span class="comment">  T. R. Koehler, D. R. Fredkin,</span>
<a name="l00127"></a>00127 <span class="comment">  &quot;Finite Element Methods for Micromagnetics&quot;</span>
<a name="l00128"></a>00128 <span class="comment">  IEEE Trans. Magn. 28 (1992) 1239-1244</span>
<a name="l00129"></a>00129 <span class="comment"></span>
<a name="l00130"></a>00130 <span class="comment">  matrix elements calculated according to:</span>
<a name="l00131"></a>00131 <span class="comment">  D. A. Lindholm,</span>
<a name="l00132"></a>00132 <span class="comment">  &quot;Three-Dimensional Magnetostatic Fields from</span>
<a name="l00133"></a>00133 <span class="comment">  Point-Matched Integral Equations with Linearly Varying Scalar Sources&quot;,</span>
<a name="l00134"></a>00134 <span class="comment">  IEEE Trans. Magn. MAG-20 (1984) 2025-2032.</span>
<a name="l00135"></a>00135 <span class="comment">  */</span>
<a name="l00136"></a>00136 
<a name="l00137"></a>00137   <span class="comment">/* loop over all (!) vertices (R) */</span>
<a name="l00138"></a>00138   <span class="keywordtype">int</span> i;
<a name="l00139"></a>00139   <span class="keywordflow">for</span> (i=0; i&lt;gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>; i++) {
<a name="l00140"></a>00140     ierr = <a class="code" href="progressbar_8c.html#afac4bb91f0e22a14a209a0f60113654d">ProgressBar</a>(i,gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>,10);
<a name="l00141"></a>00141     <span class="comment">/* skip if R is not a boundary node */</span>
<a name="l00142"></a>00142     <span class="keywordflow">if</span> (gdata-&gt;<a class="code" href="structGridData.html#a61acba7bde22d0fdea2069433662f6b5">vertbndg2bnd</a>[i]==<a class="code" href="griddata_8h.html#af23ac2ffd709eb569a1f0c98d06be299">C_INT</a>) <span class="keywordflow">continue</span>;
<a name="l00143"></a>00143 
<a name="l00144"></a>00144     <span class="comment">/* loop over local surface triangles */</span>
<a name="l00145"></a>00145 
<a name="l00146"></a>00146     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=0; j&lt;gdata-&gt;<a class="code" href="structGridData.html#af59cf93f7a91c270b9f07c2bf2453e25">ln_bnd_fac</a>; j++) {
<a name="l00147"></a>00147       <span class="comment">/* skip if R is a node of j */</span>
<a name="l00148"></a>00148       <span class="keywordflow">if</span> (gdata-&gt;<a class="code" href="structGridData.html#a018ce7264f478c6eae964c4a753a796b">bndfacvert</a>[j*<a class="code" href="griddata_8h.html#a170755e30c36be4904106b7bb279b1ec">NN</a>+0]==i ||
<a name="l00149"></a>00149           gdata-&gt;<a class="code" href="structGridData.html#a018ce7264f478c6eae964c4a753a796b">bndfacvert</a>[j*<a class="code" href="griddata_8h.html#a170755e30c36be4904106b7bb279b1ec">NN</a>+1]==i ||
<a name="l00150"></a>00150           gdata-&gt;<a class="code" href="structGridData.html#a018ce7264f478c6eae964c4a753a796b">bndfacvert</a>[j*<a class="code" href="griddata_8h.html#a170755e30c36be4904106b7bb279b1ec">NN</a>+2]==i
<a name="l00151"></a>00151       ) <span class="keywordflow">continue</span>;
<a name="l00152"></a>00152 
<a name="l00153"></a>00153       PetscReal matele[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>];
<a name="l00154"></a>00154       ierr = <a class="code" href="bele_8c.html#affb52b9f2b0f2fd0d97c0519704464c8">Bele</a>(
<a name="l00155"></a>00155                   gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>+<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i,
<a name="l00156"></a>00156                   gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>+<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a018ce7264f478c6eae964c4a753a796b">bndfacvert</a>[j*<a class="code" href="griddata_8h.html#a170755e30c36be4904106b7bb279b1ec">NN</a>+0],
<a name="l00157"></a>00157                   gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>+<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a018ce7264f478c6eae964c4a753a796b">bndfacvert</a>[j*<a class="code" href="griddata_8h.html#a170755e30c36be4904106b7bb279b1ec">NN</a>+1],
<a name="l00158"></a>00158                   gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>+<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#a018ce7264f478c6eae964c4a753a796b">bndfacvert</a>[j*<a class="code" href="griddata_8h.html#a170755e30c36be4904106b7bb279b1ec">NN</a>+2],
<a name="l00159"></a>00159                   matele
<a name="l00160"></a>00160       );CHKERRQ(ierr);
<a name="l00161"></a>00161 
<a name="l00162"></a>00162       <span class="keywordflow">if</span> (PetscAbsReal(matele[0])+PetscAbsReal(matele[1])+PetscAbsReal(matele[2])&lt;<a class="code" href="griddata_8h.html#a26ab586dda1b8c780aa849e457c0cbad">D_EPS</a>)
<a name="l00163"></a>00163         <span class="keywordflow">continue</span>;
<a name="l00164"></a>00164 
<a name="l00165"></a>00165       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> k=0;k&lt;<a class="code" href="griddata_8h.html#a170755e30c36be4904106b7bb279b1ec">NN</a>;k++) {
<a name="l00166"></a>00166         <span class="comment">/* set (dense) full boundary matrix */</span>
<a name="l00167"></a>00167         ierr = MatSetValue(B,
<a name="l00168"></a>00168           gdata-&gt;<a class="code" href="structGridData.html#a61acba7bde22d0fdea2069433662f6b5">vertbndg2bnd</a>[i],
<a name="l00169"></a>00169           gdata-&gt;<a class="code" href="structGridData.html#a61acba7bde22d0fdea2069433662f6b5">vertbndg2bnd</a>[gdata-&gt;<a class="code" href="structGridData.html#a018ce7264f478c6eae964c4a753a796b">bndfacvert</a>[j*NN+k]],
<a name="l00170"></a>00170           matele[k],
<a name="l00171"></a>00171         ADD_VALUES);CHKERRQ(ierr);
<a name="l00172"></a>00172       }
<a name="l00173"></a>00173     }
<a name="l00174"></a>00174 
<a name="l00175"></a>00175     <span class="comment">/* flush caches to save memory (and avoid swapping) */</span>
<a name="l00176"></a>00176     <span class="keywordflow">if</span> (i % 100 == 99) {
<a name="l00177"></a>00177       ierr = MatAssemblyBegin(B,MAT_FLUSH_ASSEMBLY);CHKERRQ(ierr);
<a name="l00178"></a>00178       ierr = MatAssemblyEnd(B,MAT_FLUSH_ASSEMBLY);CHKERRQ(ierr);
<a name="l00179"></a>00179     }
<a name="l00180"></a>00180 
<a name="l00181"></a>00181   }
<a name="l00182"></a>00182   ierr = <a class="code" href="progressbar_8c.html#afac4bb91f0e22a14a209a0f60113654d">ProgressBar</a>(1,1,10);
<a name="l00183"></a>00183 
<a name="l00184"></a>00184   <span class="keywordflow">if</span> (size&gt;1) {
<a name="l00185"></a>00185     ierr = PetscGetTime(&amp;t_t2);CHKERRQ(ierr);
<a name="l00186"></a>00186     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;&lt;%i&gt; took %g s\n&quot;</span>,rank,t_t2-t_t1);
<a name="l00187"></a>00187     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;waiting for other processors to complete...&quot;</span>);
<a name="l00188"></a>00188   }
<a name="l00189"></a>00189 
<a name="l00190"></a>00190   <span class="comment">/* continue assembling to stay in sync with other processors */</span>
<a name="l00191"></a>00191   <span class="keywordflow">for</span> (;i&lt;gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>;i++) {
<a name="l00192"></a>00192     <span class="keywordflow">if</span> (i % 100 == 99) {
<a name="l00193"></a>00193       ierr = MatAssemblyBegin(B,MAT_FLUSH_ASSEMBLY);CHKERRQ(ierr);
<a name="l00194"></a>00194       ierr = MatAssemblyEnd(B,MAT_FLUSH_ASSEMBLY);CHKERRQ(ierr);
<a name="l00195"></a>00195     }
<a name="l00196"></a>00196   }
<a name="l00197"></a>00197 
<a name="l00198"></a>00198   <span class="comment">/* TODO not quite accurate */</span>
<a name="l00199"></a>00199   <span class="keywordtype">int</span> tzeroes=0;
<a name="l00200"></a>00200   ierr=MPI_Allreduce((<span class="keywordtype">int</span>*)&amp;zeroes,(<span class="keywordtype">int</span>*)&amp;tzeroes,1,MPI_INT,MPI_SUM,PETSC_COMM_WORLD);CHKERRQ(ierr);
<a name="l00201"></a>00201   PetscInfo3(0,
<a name="l00202"></a>00202     <span class="stringliteral">&quot;total zero entries: %i (%i) of %i\n&quot;</span>,
<a name="l00203"></a>00203     (tzeroes+gdata-&gt;<a class="code" href="structGridData.html#a916cbd12c058654799cd18db685734c5">n_vert_bnd</a>)/3,
<a name="l00204"></a>00204     tzeroes,
<a name="l00205"></a>00205     gdata-&gt;<a class="code" href="structGridData.html#a916cbd12c058654799cd18db685734c5">n_vert_bnd</a>*gdata-&gt;<a class="code" href="structGridData.html#a916cbd12c058654799cd18db685734c5">n_vert_bnd</a>
<a name="l00206"></a>00206   );
<a name="l00207"></a>00207 
<a name="l00208"></a>00208   ierr = PetscGetTime(&amp;t_t2);CHKERRQ(ierr);
<a name="l00209"></a>00209   PetscPrintf(PETSC_COMM_WORLD,
<a name="l00210"></a>00210     <span class="stringliteral">&quot;boundary matrix calculation took %g s = %g min\n&quot;</span>,
<a name="l00211"></a>00211     t_t2-t_t1,
<a name="l00212"></a>00212     (t_t2-t_t1)/60.0
<a name="l00213"></a>00213   );
<a name="l00214"></a>00214 
<a name="l00215"></a>00215   <span class="comment">/* set diagonal matrix elements */</span>
<a name="l00216"></a>00216 
<a name="l00217"></a>00217   Vec vertbsa; <span class="comment">/* boundary solid angle (4*pi for interior vertices) */</span>
<a name="l00218"></a>00218   ierr = VecCreate(PETSC_COMM_WORLD,&amp;vertbsa);CHKERRQ(ierr);
<a name="l00219"></a>00219   ierr = VecSetSizes(vertbsa,gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>,gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>);CHKERRQ(ierr);
<a name="l00220"></a>00220   ierr = VecSetFromOptions(vertbsa);CHKERRQ(ierr);
<a name="l00221"></a>00221 
<a name="l00222"></a>00222   ierr = <a class="code" href="bmatrix_8c.html#a6ef9ef50f16bc7123b3585a730fa9afa">VertBSA</a>(gdata,vertbsa);CHKERRQ(ierr);
<a name="l00223"></a>00223 
<a name="l00224"></a>00224   PetscReal *t_array;
<a name="l00225"></a>00225   ierr = VecGetArray(vertbsa,&amp;t_array);CHKERRQ(ierr);
<a name="l00226"></a>00226 
<a name="l00227"></a>00227   <span class="keywordflow">for</span> (i=0; i&lt;gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>; i++) {
<a name="l00228"></a>00228 
<a name="l00229"></a>00229     <span class="comment">/* skip if R is not a boundary node */</span>
<a name="l00230"></a>00230     <span class="keywordflow">if</span> (gdata-&gt;<a class="code" href="structGridData.html#a61acba7bde22d0fdea2069433662f6b5">vertbndg2bnd</a>[gdata-&gt;<a class="code" href="structGridData.html#a45017e8b920340403c64fa136a33044a">vertl2g</a>[i]]==<a class="code" href="griddata_8h.html#af23ac2ffd709eb569a1f0c98d06be299">C_INT</a>) <span class="keywordflow">continue</span>;
<a name="l00231"></a>00231 
<a name="l00232"></a>00232     PetscReal matele;
<a name="l00233"></a>00233     matele=t_array[i]/(4.0*PETSC_PI)-1.0;
<a name="l00234"></a>00234     ierr = MatSetValue(B,
<a name="l00235"></a>00235       gdata-&gt;<a class="code" href="structGridData.html#a61acba7bde22d0fdea2069433662f6b5">vertbndg2bnd</a>[gdata-&gt;<a class="code" href="structGridData.html#a45017e8b920340403c64fa136a33044a">vertl2g</a>[i]],
<a name="l00236"></a>00236       gdata-&gt;<a class="code" href="structGridData.html#a61acba7bde22d0fdea2069433662f6b5">vertbndg2bnd</a>[gdata-&gt;<a class="code" href="structGridData.html#a45017e8b920340403c64fa136a33044a">vertl2g</a>[i]],
<a name="l00237"></a>00237       matele,
<a name="l00238"></a>00238     ADD_VALUES);CHKERRQ(ierr);
<a name="l00239"></a>00239   }
<a name="l00240"></a>00240 
<a name="l00241"></a>00241   ierr = VecRestoreArray(vertbsa,&amp;t_array);CHKERRQ(ierr);
<a name="l00242"></a>00242   ierr = VecDestroy(vertbsa);CHKERRQ(ierr);
<a name="l00243"></a>00243 
<a name="l00244"></a>00244   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;B matrix assembly complete\n&quot;</span>);
<a name="l00245"></a>00245   ierr = MatAssemblyBegin(B,MAT_FINAL_ASSEMBLY);CHKERRQ(ierr);
<a name="l00246"></a>00246   ierr = MatAssemblyEnd(B,MAT_FINAL_ASSEMBLY);CHKERRQ(ierr);
<a name="l00247"></a>00247   ierr = <a class="code" href="printmatinfo_8c.html#a8c62a6053be02438e1bf2da1efa06f1f">PrintMatInfoAll</a>(B);CHKERRQ(ierr);
<a name="l00248"></a>00248 
<a name="l00249"></a>00249   <span class="comment">/* scale B*=-1 since Au2*=-1 and ABu2*=1 is not */</span>
<a name="l00250"></a>00250   ierr = MatScale(B,-1.0);CHKERRQ(ierr);
<a name="l00251"></a>00251 
<a name="l00252"></a>00252   *Bmat=B;
<a name="l00253"></a>00253 
<a name="l00254"></a>00254 <span class="comment">/* DEBUG</span>
<a name="l00255"></a>00255 <span class="comment">  PetscPrintf(PETSC_COMM_WORLD,&quot;B matrix::\n&quot;);</span>
<a name="l00256"></a>00256 <span class="comment">  ierr = MatView(B,PETSC_VIEWER_STDOUT_WORLD);CHKERRQ(ierr);</span>
<a name="l00257"></a>00257 <span class="comment">*/</span>
<a name="l00258"></a>00258 
<a name="l00259"></a>00259 <span class="comment">/* DEBUG</span>
<a name="l00260"></a>00260 <span class="comment">  ierr = PetscViewerSetFormat(PETSC_VIEWER_DRAW_WORLD,PETSC_VIEWER_ASCII_DENSE);CHKERRQ(ierr);</span>
<a name="l00261"></a>00261 <span class="comment">  ierr = MatView(B,PETSC_VIEWER_DRAW_WORLD);CHKERRQ(ierr);</span>
<a name="l00262"></a>00262 <span class="comment"></span>
<a name="l00263"></a>00263 <span class="comment">  char fmesh[256];</span>
<a name="l00264"></a>00264 <span class="comment">  PetscViewer viewer;</span>
<a name="l00265"></a>00265 <span class="comment"></span>
<a name="l00266"></a>00266 <span class="comment">  ierr = PetscSNPrintf(fmesh,255,&quot;%s%s&quot;,gdata-&gt;simname,&quot;.ba&quot;);CHKERRQ(ierr);</span>
<a name="l00267"></a>00267 <span class="comment">  ierr = PetscViewerASCIIOpen(PETSC_COMM_WORLD,fmesh,&amp;viewer);CHKERRQ(ierr);</span>
<a name="l00268"></a>00268 <span class="comment">  ierr = PetscViewerSetFormat(viewer,PETSC_VIEWER_ASCII_DENSE);CHKERRQ(ierr);</span>
<a name="l00269"></a>00269 <span class="comment">  ierr = MatView(B,viewer);CHKERRQ(ierr);</span>
<a name="l00270"></a>00270 <span class="comment">  ierr = PetscViewerDestroy(viewer);CHKERRQ(ierr);</span>
<a name="l00271"></a>00271 <span class="comment">*/</span>
<a name="l00272"></a>00272 
<a name="l00273"></a>00273   ierr = PetscGetTime(&amp;t_t2);CHKERRQ(ierr);
<a name="l00274"></a>00274 
<a name="l00275"></a>00275   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00276"></a>00276 }
<a name="l00277"></a>00277 
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

